program tree;
uses crt,graph;
const width=600;
      height=400;
      path_to_graph='BGI\';
type link_type=^element_type;
     element_type=record value:integer;
                         left_link:link_type;
                         right_link:link_type;
                         end;
procedure menu;
  begin
    writeln('1-dobavit v derevo');
    writeln('2-ochistit derevo');
    writeln('3-lkp');
    writeln('4-klp');
    writeln('5-pokazat glubinu dereva');
    writeln('6-pokazat kolichestvo uzlov na urovne (koren - 0 uroven)');
    writeln('7-narisovat derevo');
    writeln('8-udalit element');
    writeln('9-naiti element po znacheniu');
    writeln('10-Bb|XOg');
  end;
procedure add(var root:pointer; user:boolean; new_value:integer; var f:text);
var element,prev_element:link_type;
    orient:string;
  begin
    if (root<>nil)
    then
      begin
        element:=root;
        repeat
          if (new_value>element^.value)
          then
            begin
              prev_element:=element;
              element:=element^.right_link;
              orient:='right';
            end
          else
            begin
              prev_element:=element;
              element:=element^.left_link;
              orient:='left';
            end;
        until (element=nil);
        element:=prev_element;
        if (orient='right')
        then
          begin
            new(element^.right_link);
            element:=element^.right_link;
          end
        else
          begin
            new(element^.left_link);
            element:=element^.left_link;
          end;
      end
    else
      begin
        new(element);
        root:=element;
      end;
    element^.value:=new_value;
    element^.left_link:=nil;
    element^.right_link:=nil;
    if (not user)
    then
      begin
        writeln(f,'ok');
      end;
  end;
procedure clear_element(element:link_type);
  begin
    if (element^.left_link<>nil)
    then
      begin
        clear_element(element^.left_link);
      end;
    if (element^.right_link<>nil)
    then
      begin
        clear_element(element^.right_link);
      end;
    dispose(element);
  end;
procedure clear(var root:pointer; user:boolean; var f:text);
var element:link_type;
  begin
    element:=root;
    clear_element(element);
    root:=nil;
    if (not user)
    then
      begin
        writeln(f,'ok');
      end;
  end;
function search_on_level(element:link_type; current_level,level:integer):integer;
var count,new_count:integer;
  begin
    count:=0;
    if (level=current_level)
    then
      begin
        count:=count+1;
      end;
    if (element^.left_link<>nil)
    then
      begin
        new_count:=search_on_level(element^.left_link,current_level+1,level);
        count:=count+new_count;
      end;
    if (element^.right_link<>nil)
    then
      begin
        new_count:=search_on_level(element^.right_link,current_level+1,level);
        count:=count+new_count;
      end;
    search_on_level:=count;
  end;
procedure level_count(root:pointer; user:boolean; level:integer; var f:text);
var element:link_type;
    count,current_level:integer;
  begin
    if (root<>nil)
    then
      begin
        element:=root;
        current_level:=0;
        count:=search_on_level(element,current_level,level);
        if (user)
        then
          begin
            writeln('Kolichestvo=',count);
            readln;
          end
        else
          begin
            writeln(f,count);
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('0');
            readln;
          end
        else
          begin
            writeln(f,0);
          end;
      end;
  end;
procedure klp(element:link_type; user:boolean; var f:text; output:boolean; var count:integer);
  begin
    if (element<>nil)
    then
      begin
        count:=count+1;
        if (output)
        then
          begin
            if (user)
            then
              begin
                write(element^.value,' ');
              end
            else
              begin
                write(f,element^.value);
                write(f,' ');
              end;
          end;
        klp(element^.left_link,user,f,output,count);
        klp(element^.right_link,user,f,output,count);
      end;
  end;
procedure lkp(element:link_type;user:boolean;var f:text);
  begin
    if (element<>nil)
    then
      begin
        if (element^.left_link<>nil)
        then
          begin
            lkp(element^.left_link,user,f);
          end;
        if (user)
        then
          begin
            write(element^.value,' ');
          end
        else
          begin
            write(f,element^.value);
            write(f,' ');
          end;
        if (element^.right_link<>nil)
        then
          begin
            lkp(element^.right_link,user,f);
          end;
      end;
  end;
procedure print_lkp(root:pointer; user:boolean; var f:text);
var element:link_type;
  begin
    if (root<>nil)
    then
      begin
        element:=root;
        lkp(element,user,f);
        if (user)
        then
          readln;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('Derevo pustoe. Press enter');
            readln;
          end;
      end;
    if (not user)
    then
      begin
        writeln(f);
      end;
  end;
procedure print_klp(root:pointer; user:boolean; var f:text);
var count:integer;
    element:link_type;
    output:boolean;
  begin
    if (root<>nil)
    then
      begin
        element:=root;
        output:=TRUE;
        count:=0;
        klp(element,user,f,output,count);
        if ((output)and(user))
        then
          readln;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('Derevo pustoe. Press enter');
            readln;
          end;
      end;
    if (not user)
    then
      begin
        writeln(f);
      end;
  end;
function search_deep(element:link_type; deep:integer):integer;
var deep_right,deep_left:integer;
  begin
    if (element<>nil)
    then
      begin
        deep:=deep+1;
        deep_left:=search_deep(element^.left_link,0);
        deep_right:=search_deep(element^.right_link,0);
        if (deep_left>deep_right)
        then
          begin
            deep:=deep+deep_left;
          end
        else
          begin
           deep:=deep+deep_right;
          end;
        search_deep:=deep;
      end
    else
      begin
        search_deep:=deep;
      end;
  end;
procedure watch_deep(root:pointer; user:boolean; var f:text);
var element:link_type;
    deep:integer;
  begin
    element:=root;
    deep:=0;
    deep:=search_deep(element,deep);
    if (user)
    then
      begin
        writeln(deep);
        readln;
      end
    else
      begin
        writeln(f,deep);
      end;
  end;
procedure paint_klp(element:link_type; start_x,end_x,start_y,end_y:integer;user:boolean;var f:text;
 vertical_count,deep:integer);
var x,y,start_center_x,end_center_x,distance_x,distance_y:real;
    element_string:string;
    output:boolean;
    left_count,right_count,count,local_width:integer;
  begin
    output:=FALSE;
    count:=0;
    left_count:=0;
    right_count:=0;
    klp(element^.left_link,user,f,output,left_count);
    klp(element^.right_link,user,f,output,right_count);
    klp(element,user,f,output,count);
    local_width:=end_x-start_x;
    start_center_x:=start_x+local_width*left_count/count;
    end_center_x:=start_x+local_width*(left_count+1)/count;
    distance_x:=local_width/count/2;
    distance_y:=(end_y-start_y)/vertical_count/2;
    y:=start_y+(end_y-start_y)/vertical_count*deep-(end_y-start_y)/vertical_count/2;
    x:=start_center_x+local_width/count/2;
    if (deep<>1)
    then
      lineto(round(x),round(y-distance_y/2));
    setcolor(white);
    ellipse(round(x),round(y),0,360,round(distance_x/2),round(distance_y/2));
    str(element^.value,element_string);
    outtextxy(round(x),round(y),element_string);
    moveto(round(x),round(y+distance_y/2));
    if (element^.left_link<>nil)
    then
      begin
        paint_klp(element^.left_link,start_x,round(start_center_x),start_y,end_y,user,f,vertical_count,deep+1);
        moveto(round(x),round(y+distance_y/2));
      end;
    if (element^.right_link<>nil)
    then
      begin
        paint_klp(element^.right_link,round(end_center_x),end_x,start_y,end_y,user,f,vertical_count,deep+1);
        moveto(round(x),round(y+distance_y/2));
      end;
  end;
procedure paint(root:pointer; user:boolean; var f:text);
var element:link_type;
    vertical_count,gd,gm,deep:integer;
  begin
    if (root<>nil)
    then
      begin
        element:=root;
        vertical_count:=search_deep(element,0);
        gd:=0;
        gm:=0;
        initgraph(gd,gm,path_to_graph);
        deep:=1;
        paint_klp(element,0,width,0,height,user,f,vertical_count,deep);
        readln;
        closegraph;
        if (not user)
        then
          begin
            writeln(f,'ok');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('Derevo pustoe');
            readln;
          end
        else
          begin
            writeln(f,'error');
          end;
      end;
  end;
function find_element(element:link_type; value:integer; var element_prev:link_type;
var link:string):link_type;
var finded,element_not_exists:boolean;
  begin
    find_element:=nil;
    finded:=FALSE;
    element_not_exists:=FALSE;
    while ((not finded)and(not element_not_exists)) do
      begin
        if (element^.value=value)
        then
          begin
            find_element:=element;
            finded:=TRUE;
          end
        else
          begin
            if (value<element^.value)
            then
              begin
                if (element^.left_link<>nil)
                then
                  begin
                    element_prev:=element;
                    link:='left';
                    element:=element^.left_link;
                  end
                else
                  begin
                    element_not_exists:=TRUE;
                  end;
              end;
            if (value>element^.value)
            then
              begin
                if (element^.right_link<>nil)
                then
                  begin
                    element_prev:=element;
                    link:='right';
                    element:=element^.right_link;
                  end
                else
                  begin
                    element_not_exists:=TRUE;
                  end
              end;
          end;
      end;
  end;
function find_element_max(element:link_type; var element_prev:link_type; var link:string):link_type;
  begin
    element_prev:=nil;
    if (element<>nil)
    then
      begin
        if (element^.left_link<>nil)
        then
          begin
            element:=element^.left_link;
            link:='right_clear';
            while (element^.right_link<>nil) do
              begin
                link:='right';
                element_prev:=element;
                element:=element^.right_link;
              end;
            find_element_max:=element;
          end
        else
          begin
            if (element^.right_link<>nil)
            then
              begin
                link:='left';
                find_element_max:=element^.right_link;
              end
            else
              begin
                find_element_max:=nil;
              end;
          end;
      end;
  end;
procedure delete_element(value:integer; var root:pointer; user:boolean; var f:text);
var element,element_prev,element_max,element_max_prev:link_type;
    link,link2:string;
  begin
    if (root<>nil)
    then
      begin
        element_prev:=nil;
        link:='';
        element:=find_element(root,value,element_prev,link);
        element_max:=find_element_max(element,element_max_prev,link2);
        if (element<>nil)
        then
          begin
            if (element_prev<>nil)
            then
              begin
                if (element_max<>nil)
                then
                  begin
                    if (link='left')
                    then
                      begin
                        element_prev^.left_link:=element_max;
                        if (link2='right')
                        then
                          begin
                            element_max_prev^.right_link:=element_max^.left_link;
                            element_max^.left_link:=element^.left_link;
                            element_max^.right_link:=element^.right_link;
                          end;
                        if (link2='right_clear')
                        then
                          begin
                            element_max^.right_link:=element^.right_link;
                          end;
                        dispose(element);
                      end
                    else
                      begin
                        element_prev^.right_link:=element_max;
                        if (link2='right')
                        then
                          begin
                            element_max_prev^.right_link:=element_max^.left_link;
                            element_max^.left_link:=element^.left_link;
                            element_max^.right_link:=element^.right_link;
                          end;
                        if (link2='right_clear')
                        then
                          begin
                            element_max^.right_link:=element^.right_link;
                          end;
                        dispose(element);
                      end;
                  end
                else
                  begin
                    if (link='left')
                    then
                      element_prev^.left_link:=element^.left_link
                    else
                      element_prev^.right_link:=element^.left_link;
                    dispose(element);
                  end;
              end
            else
              begin
                if (element_max<>nil)
                then
                  begin
                    root:=element_max;
                    if (link2='right')
                    then
                      begin
                        element_max_prev^.right_link:=element_max^.left_link;
                        element_max^.left_link:=element^.left_link;
                        element_max^.right_link:=element^.right_link;
                      end;
                    if (link2='right_clear')
                    then
                      begin
                        element_max^.right_link:=element^.right_link;
                      end;
                    dispose(element);
                  end
                else
                  begin
                    root:=element^.left_link;
                    dispose(element);
                  end;
              end;
            if (not user)
            then
              writeln(f,'ok');
          end
        else
          begin
            if (user)
            then
              begin
                writeln('Elementa ne suschesrvuet. Press enter.');
                readln;
              end
            else
              begin
                writeln(f,'error');
              end;
          end;
      end
    else
      begin
        if (user)
          then
            begin
              writeln('Derevo pustoe. Press enter.');
              readln;
            end
          else
            begin
              writeln(f,'error');
            end;
      end;
  end;
procedure search_element(root:pointer; user:boolean; value:integer; var f:text);
var finded,element_not_exists:boolean;
    element:link_type;
  begin
    finded:=FALSE;
    element_not_exists:=FALSE;
    element:=root;
    while ((not finded)and(not element_not_exists)) do
      begin
        if (element^.value=value)
        then
          begin
            finded:=TRUE;
          end
        else
          begin
            if (value<element^.value)
            then
              begin
                if (element^.left_link<>nil)
                then
                  begin
                    element:=element^.left_link;
                  end
                else
                  begin
                    element_not_exists:=TRUE;
                  end;
              end;
            if (value>element^.value)
            then
              begin
                if (element^.right_link<>nil)
                then
                  begin
                    element:=element^.right_link;
                  end
                else
                  begin
                    element_not_exists:=TRUE;
                  end
              end;
          end;
      end;
    if (finded)
    then
      begin
        if (user)
        then
          begin
            writeln('Element naiden. press enter.');
            readln;
          end
        else
          begin
            writeln(f,'ok');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('Element ne naiden. press enter.');
            readln;
          end
        else
          begin
            writeln(f,'no');
          end;
      end;
  end;
procedure user_interface(root:pointer);
var action_code,new_value,level,value:integer;
    user:boolean;
    var f:text;
  begin
     user:=TRUE;
    repeat
      clrscr;
      menu;
      writeln('action code:');
      readln(action_code);
      case action_code of
      1:begin
          write('value=');
          readln(new_value);
          add(root,user,new_value,f);
        end;
      2:clear(root,user,f);
      6:begin
          write('uroven=');
          readln(level);
          level_count(root,user,level,f);
        end;
      3:print_lkp(root,user,f);
      4:print_klp(root,user,f);
      5:watch_deep(root,user,f);
      7:paint(root,user,f);
      8:begin
          write('element=');
          readln(value);
          delete_element(value,root,user,f);
        end;
      9:begin
          write('element=');
          readln(value);
          search_element(root,user,value,f);
        end;
      end;
    until (action_code=10);
  end;
procedure file_interface(root:pointer; read_file,write_file:string);
var user:boolean;
    p,parametr:integer;
    f,f2:text;
    s,action,parametr_string:string;
  begin
    user:=FALSE;
    assign(f2,read_file);
    reset(f2);
    assign(f,write_file);
    rewrite(f);
    while (not eof(f2)) do
      begin
        readln(f2,s);
        p:=pos(' ',s);
        action:=copy(s,1,p-1);
        if (p=0)
        then
          begin
            action:=s;
          end;
        parametr_string:=copy(s,p+1,length(s)-p);
        val(parametr_string,parametr,p);
        if (action='add')
        then
          begin
            add(root,user,parametr,f);
          end;
        if (action='clear')
        then
          begin
            clear(root,user,f);
          end;
        if (action='LKP')
        then
          begin
            print_lkp(root,user,f);
          end;
        if (action='KLP')
        then
          begin
            print_klp(root,user,f);
          end;
        if (action='deep')
        then
          begin
            watch_deep(root,user,f);
          end;
        if (action='level')
        then
          begin
            level_count(root,user,parametr,f);
          end;
        if (action='paint')
        then
          begin
            paint(root,user,f);
          end;
        if (action='del')
        then
          begin
            delete_element(parametr,root,user,f);
          end;
        if (action='find')
        then
          begin
            search_element(root,user,parametr,f);
          end;
      end;
    close(f2);
    close(f);
  end;
var read_file,write_file:string;
    root:pointer;
begin
  root:=nil;
  if (paramstr(1)<>''){᫨  ࠬ  ப}
  then{}
    begin
      read_file:=paramstr(1);{뢠 䠩 -  ࠬ}
      write_file:=paramstr(2);{室 䠩 - ன ࠬ}
      file_interface(root,read_file,write_file);
    end
  else{᫨ , }
    begin
      user_interface(root);
    end;
end.
